----------------------------------------------------------------------------
--
-- © Copyright CERN 2000-2021. All rigths reserved. This software is released under a CERN proprietary software licence.
-- Any permission to use it shall be granted in writing. Request shall be adressed to CERN through mail-KT@cern.ch
--
----------------------------------------------------------------------------

%parser Table_LGCOutputErrLexer
%decl LGCOutputErrLexer.hpp
%impl LGCOutputErrLexer_gen.cpp


-- BASIC TOKENS
%token EOL_SYMBOL "New line '\\n'"
%token WORD "Word"
%token INTEGER "Integer number"
%token DECIMAL "Decimal number"
-- Special characters
%token COLON ":"
%token EQUAL "="
%token ASTERISK "*"

-- KEYWORDS
	-- HEADER
		%token SUMMARY_START "LGC2"
	-- SUMMARY
		%token SUMMARY_SIGMA "SIGMA ZERO A POSTERIORI"
		%token SUMMARY_SIGNIFICANCE "SIGNIFICANCE LEVEL FOR TESTING WI, ALPHA"
		%token SUMMARY_POWER "POWER OF TEST TO DETERMINE NABLA AND DELTY"
	-- FRAMES
		%token FRAME "FRAME"
		%token FRAMESLAVE "SLAVE"
		%token FRAME_PARAMETER "PARAMETER"
		-- FRAMES ROTATIONS AND TRANSLATIONS
			% token XY "XY"
			% token XZ "XZ"
			% token YZ "YZ"
	-- OBSERVATIONS
		%token FRAME "FRAME"
		%token STATION "STATION"
		%token LINE "LINE"
		%token PIVOT "PIVOT"
		%token OBSERVATION "OBSERVATION"
		%token OBS_j "OBS_j"
		%token OBS_dist "OBS_dist"
		%token PT "PT"
		%token POINT "POINT"
		%token WIRE "WIRE"
	-- MEASUREMENTS
		-- POLAR
			%token ANGL "ANGL"
			%token ZEND "ZEND"
			%token DIST "DIST"
			%token ECTH "ECTH"
			%token ECDIR "ECDIR"
			%token DHOR "DHOR"
			%token PLR3D "PLR3D"
			%token ORIE "ORIE"
		-- CAMD
			%token UVEC "UVEC"
			%token UVD "UVD"
		-- EDM
			%token DSPT "DSPT"
		-- LEVEL
			%token DLEV "DLEV"
		-- SCALE
			%token ECHO "ECHO"
			%token ECSP "ECSP"
			%token ECVE "ECVE"
		-- INCL
			%token INCLY "INCLY"
		-- HLSR
			%token ECWS "ECWS"
		-- WPSR
			%token ECWI "ECWI"
		-- NO TYPE
			%token DVER "DVER"
			%token OBSXYZ "OBSXYZ"
			%token RADI "RADI"
		-- HISTOGRAMS
			%token REPARTITION "REPARTITION"

	-- UNDEFINED AND ERRORS
		%token ILLMEASUREMENT "**-"
		%token INDETERMINE "INDETERMINE"
		%token IND1000 "IND1000.00"
		%token INFINI "INFINI"
		%token IND "IND"
		%token EXCLAMATION "!"
		%token ERR_ASTERISKS "**"
	
	
-- STARTING POINT
%start ErrRes

-- LGCOutputErrLexer.hpp

/:
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputErrLexer.g.
 * /!\ Don't edit it!
 */

#ifndef LGCOUTPUTLERRLEXER_HPP
#define LGCOUTPUTLERRLEXER_HPP

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "LGCMeasures.hpp"

#include "$header"

class LGCOutputErrLexer : public LexerParser<$table>
{
	Q_OBJECT

public:
	LGCOutputErrLexer(QObject *parent = nullptr);
	virtual ~LGCOutputErrLexer() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		Normal,
		Comment,
		/** Values */
		ValueImportant,
		ValueError,
		ValueCorrect,
		/** Table */
		TablePoint,
		TableHeader,
		TableHeaderUnits,
		TableFrameTransformation,
		/** Frames */
		Frame,
		FrameName,
		/** Overall Reliability */
		OverallReliability,
	};
	/**
	 * Uses the input measures to create links between input and output file.
	 *
	 * @warning This method must be called before opening the output file.
	 */
	void lgcMeasures(LGCMeasures measures) noexcept
	{
		_inputData = std::move(measures);
		_inputData.instruments.clear();
		_inputData.measures.clear();
		_inputData.targets.clear();
	}
	const LGCMeasures &lgcMeasures() const noexcept { return _inputData; }
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual const char *language() const override { return "LGCPointErr"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual const std::string &getMIMEType() const override { static std::string _tmp = ""; return _tmp; }
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &) override { return std::string(); }
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &) override { return std::string(); }
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &) override { return std::string(); }
	virtual std::string write(const ShareablePosition &) override { return std::string(); }

protected:
	// TextLexer
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual QString calltip(int position, int indicatorType, const QString &indicator) const override;

private:
	// LexerParser
	// generated in in LGCOutputErrLexer_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;
	
	/** used in lexer */
	void checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK = Styles::Normal, Styles styleError = Styles::ValueError);
	
	// implemented in LGCOutputErrLexer_impl.cpp
	/** Called each time we meet a point name */
	void setPoint(QStringRef sym);
	/** Called each time we meet a frame name */
	void setFrame(QStringRef sym);

private:
	/** input measures */
	LGCMeasures _inputData;
	/** TMP variable. Used for parsing */
	/** Temporary ints used for frame folding based on ID */
	int _curTmpFrameLevel;
	int _curTmpFrameLevelNext;
};

#endif // LGCOUTPUTLERRLEXER_HPP
:/

-- LGCOutputErrLexer_gen.cpp

/.
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputErrLexer.g.
 * /!\ Don't edit it!
 */

#include "LGCOutputErrLexer.hpp"

#include <QRegularExpression>

#include <Qsci/qsciscintilla.h>

void LGCOutputErrLexer::checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK, Styles styleError)
{
	static const QString statusstring = tr(R"""(<h1 style="color: %1;">%2</h1>
		<p style="color: %1;">Value %3 is %4.</p>)""");

	if (!_lexerMode)
		return;

	bool ok = false;
	const double value = sym(symidx).toDouble(&ok);
	if (ok && (min > max || (value >= min && value <= max)))
	{
		addStyleSym(styleOK, symidx);
		return;
	}

	addStyleSym(styleError, symidx);
	if (min == max)
		_infoAnnotation += statusstring.arg("blue").arg("Info").arg(sym(symidx).toString()).arg(tr("not %1").arg(QString::number(min)));
	else
		_errorAnnotation += statusstring.arg("red").arg("Error").arg(sym(symidx).toString()).arg(tr("out of range [%2; %3]").arg(QString::number(min), QString::number(max)));
	// add marker if none with higher priority was set before
	const int pos = sym(symidx).position();
	int line, index;
	editor()->lineIndexFromPosition(pos, &line, &index);
	const std::bitset<32> markers = editor()->markersAtLine(line);
	if (marker == TextMarker::ERROR
		|| (marker == TextMarker::WARNING && !markers[TextMarker::ERROR])
		|| (!markers[TextMarker::ERROR] && !markers[TextMarker::WARNING]))
		addMarker(editor(), pos, marker);
}

void LGCOutputErrLexer::consumeRule(int rule)
{
	switch(rule)
	{
./

----------------------------------------------------------- RULES

---- General Definitions

EOL: EOL_SYMBOL
	| EOL EOL_SYMBOL;

Number: INTEGER
	| DECIMAL;

AlNum: WORD
	| Number;

POINTNAME: WORD
/. case $rule_number: ./
	| INTEGER;

/.
	case $rule_number:
		addStyleSym(Styles::TablePoint, 1);
		setPoint(sym(1));
		break;
./

FRAMENAME: WORD;
/.
	case $rule_number:
		addStyleSym(Styles::FrameName, 1);
		setFrame(sym(1));
		break;
./
FRAMETOKEN: FRAME;
/.
	case $rule_number:
		addStyleSym(Styles::Frame, 1);
		break;
./

MeasurementToken: ANGL
	| ZEND
	| DIST
	| ECTH
	| ECDIR
	| DHOR
	| PLR3D
	| ORIE
	| UVEC
	| UVD
	| DSPT
	| DLEV
	| ECHO
	| ECSP
	| ECVE
	| ECWI
	| ECWS
	| INCLY
	| DVER
	| OBSXYZ
    | RADI;

FrameTransformationToken: XY
/. case $rule_number: ./
	| XZ
/. case $rule_number: ./
	| YZ;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::TableFrameTransformation);
		break;
./

StatisticalErrorToken: INDETERMINE
/. case $rule_number: ./
	| INFINI
/. case $rule_number: ./
	| IND;
/.
	case $rule_number:
		addStyleSym(Styles::ValueError, 1);
		break;
./
StatisticalCorrectToken: EXCLAMATION;
/.
	case $rule_number:
		addStyleSym(Styles::ValueCorrect, 1);
		break;
./
StatisticalErrorAsterisks: ERR_ASTERISKS;
/.
	case $rule_number:
		addStyleSym(Styles::ValueError, 1);
		break;
./


---- Global

ErrRes: Header Summary Frames NetworkReliability;


---- Header

Header: HeaderStartToken HeaderDef;
/.
	case $rule_number:
		endFolding();
		break;
./
HeaderDef: HeaderDef HeaderRubbish EOL
	| HeaderRubbish EOL;
HeaderStartToken: SUMMARY_START;
/.
	case $rule_number: // HeaderStartToken
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;
./
HeaderRubbish: ASTERISK
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
	| COLON
/. case $rule_number: ./
	| EQUAL
/. case $rule_number: ./
	| AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| HeaderRubbish ASTERISK
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 2);
		break;
./
	| HeaderRubbish COLON
/. case $rule_number: ./
	| HeaderRubbish EQUAL
/. case $rule_number: ./
	| HeaderRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./


---- Summary

SummaryRubbish: AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| SummaryRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./
Summary: SummarySigma SummarySignificance SummaryPower;
SummarySigma: SummarySigmaToken SummaryRubbish EQUAL SummarySigmaDef EOL;
SummarySigmaToken: SUMMARY_SIGMA;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;
./
SummarySigmaDef: Number WORD WORD WORD EQUAL WORD WORD WORD
/.
	case $rule_number:
	{
		const double sigmamin = sym(6).mid(1).toDouble(); // All after (
		const double sigmamax = sym(8).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::ValueImportant, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::ValueImportant, 8);
		break;
	}
./
	| Number WORD WORD WORD EQUAL WORD Number WORD WORD; -- TO DO: to be deleted when space between paranthesis is removed
/.
	case $rule_number:
	{
		const double sigmamin = sym(7).toDouble();
		const double sigmamax = sym(9).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		break;
	}
./
SummarySignificance: SummarySignificanceToken SummaryRubbish EQUAL SummarySignificanceDef EOL;
SummarySignificanceToken: SUMMARY_SIGNIFICANCE;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
SummarySignificanceDef: Number WORD WORD WORD WORD WORD WORD WORD WORD EQUAL Number WORD;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::Normal);
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::ValueImportant, 11);
		break;
./
SummaryPower: SummaryPowerToken SummaryRubbish EQUAL SummaryPowerDef EOL;
/.
	case $rule_number:
		endFolding();
		break;
./
SummaryPowerToken: SUMMARY_POWER;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
SummaryPowerDef: Number WORD;
/.
	case $rule_number:
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::Normal, 2);
		break;
./


---- OBSERVATIONS

Observations: Observations Obser
	| Obser; 
Obser: ObservationType EOL ObservationHeaders Measurements EOL;
ObservationType: MeasurementToken WORD;
/.
	case $rule_number:
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::ValueImportant, 2);
		break;
./
ObservationHeaders: ObservationHeaders ObservationHeader
	| ObservationHeader;
ObservationHeader: ObservationHeaderNames EOL ObservationHeaderUnits EOL;
ObservationHeaderNames: ObservationHeaderStartToken ObservationHeaderRubbish;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::TableHeader);
		break;
./
ObservationHeaderStartToken: FRAME
	| LINE
	| OBSERVATION
	| OBS_j
	| OBS_dist
	| PT
	| POINT
	| PIVOT
	| STATION
	| WIRE;
ObservationHeaderUnits: ObservationHeaderRubbish;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::TableHeaderUnits);
		break;
./
ObservationHeaderRubbish: AlNum 
	| AlNum ObservationHeaderRubbish;
	

---- MEASUREMENTS

Measurements: Measurement Measurements
	| Measurement;
Measurement: MeasurementStationTarget MeasurementStatistics EOL_SYMBOL
	| POINTNAME MeasurementStatistics EOL_SYMBOL
	| MeasurementStatistics EOL_SYMBOL;
MeasurementStatistics: MeasurementObsSigResZi MeasurementWiGiNabTiDel
	| MeasurementObsSigResZi StatisticalErrorToken StatisticalErrorToken;
MeasurementStationTarget: POINTNAME POINTNAME;
MeasurementObsSigResZi: DECIMAL Number Number Number
	| IND1000 Number Number
	| IND Number Number Number;
MeasurementWiGiNabTiDel: MeasurementWi MeasurementGiNabTiDel
	| MeasurementWi MeasurementNabTiDel;
MeasurementWi: MeasurementPreWi Number
	| Number;
MeasurementPreWi: StatisticalCorrectToken
	| StatisticalErrorAsterisks;
MeasurementNabTiDel: Number Number Number;
MeasurementGiNabTiDel: MeasurementGiNab Number Number
	| MeasurementIllGiNab Number Number;
MeasurementGiNab: StatisticalErrorAsterisks Number Number;
/.
	case $rule_number:
		addStyleSym(Styles::ValueError, 1);
		checkNumberInRange(2, -sym(3).toDouble(), sym(3).toDouble(), TextMarker::ERROR, Styles::ValueError, Styles::ValueError);
		addStyleSym(Styles::ValueImportant, 3);
		break;
./	
MeasurementIllGiNab: ILLMEASUREMENT DECIMAL;
/.
	case $rule_number:
		addStyleSym(Styles::ValueError, 1);
		addStyleSym(Styles::ValueImportant, 2);
		// The code BELOW should be replaced by checkNumberInRange when ILLMEASUREMENT is fixed in LGC
		if (abs(sym(1).split('*')[2].toDouble()) < sym(2).toDouble()) 
			break;
		_errorAnnotation += tr(R"""(<h1 style="color: red;">ERROR</h1>
			<p style="color: red;">Value %1 is out of range %2.</p>)""").arg(sym(1).split('*')[2].toString(), sym(2).toString());
		addMarker(editor(), sym(1).position(), TextMarker::ERROR);
		break;
./

-- FRAME

---- FRAME COMPONENTS

FrameDescription: FRAMETOKEN FRAMENAME FrameID EOL
	| FRAMETOKEN FRAMENAME FrameID FrameDescriptionSlave EOL;
FrameDescriptionSlave: WORD FrameRubbish;
FrameID: WORD;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::ValueImportant);
		
		_curTmpFrameLevelNext = sym(1).count('_');
		if(!_curTmpFrameLevelNext) // skip ROOT
			break; 
		else if(_curTmpFrameLevelNext < _curTmpFrameLevel) // Move from nested to outer
		{
			for (int i = 0; i < _curTmpFrameLevel - _curTmpFrameLevelNext + 1; i++)
				endFolding();
		}
		else if(_curTmpFrameLevelNext == _curTmpFrameLevel) // Move from same to same
			endFolding();
		_curTmpFrameLevel = _curTmpFrameLevelNext;
			
		startFolding();
		break;
./
FrameRubbish: FrameRubbish AlNum 
	| AlNum;

FrameHeader: FrameHeaderStartToken FrameRubbish EOL;
FrameHeaderStartToken: FRAME_PARAMETER;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::TableHeader);
		break;
./
FrameData: FrameData FrameRubbish EOL
	| FrameRubbish EOL;

FrameTransformations: FrameTransformations FrameTransformation
	| FrameTransformation;
FrameTransformation: FrameTransformationToken FrameTransformationRubbish EOL;
FrameTransformationRubbish: FrameTransformationRubbish AlNum 
	| FrameTransformationRubbish COLON
	| AlNum;

-- FRAMES

FrameDef: FrameDescription
	| FrameDescription FrameHeader FrameData;

Frame: FrameDef
	| FrameDef FrameTransformations
	| FrameDef FrameTransformations Observations
	| FrameDef Observations;

Frames: Frames Frame
	| Frame;


-- NETWORK RELIABILITY

NetworkReliability: OverallReliability EOL NetworkDOF EOL;

OverallReliability: ASTERISK ASTERISK ASTERISK WORD WORD WORD WORD Number ASTERISK ASTERISK ASTERISK
/. case $rule_number: ./
| ASTERISK ASTERISK ASTERISK WORD WORD WORD WORD WORD ASTERISK ASTERISK ASTERISK;
/.
	case $rule_number: // Network Reliability
		addStyle(_currentLine.length(), Styles::OverallReliability);
		for (int i = 0; i < (_curTmpFrameLevel); i++)
			endFolding();
		break;
./

NetworkDOF: ASTERISK ASTERISK ASTERISK WORD WORD WORD WORD Number ASTERISK ASTERISK ASTERISK;
/.
	case $rule_number: // Network Reliability
		addStyle(_currentLine.length(), Styles::OverallReliability);
		break;
./


----------------------------------------------------------- ENDRULES
/.
	} // of the switch
}

int LGCOutputErrLexer::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();
	if (tval.isEmpty())
		return LGCOutputErrLexer::WORD;
	// numbers
	if (numericrgx.match(tval).hasMatch())
	{
		bool ok;
		tval.toInt(&ok);
		if (ok)
			return LGCOutputErrLexer::INTEGER;
		tval.toDouble(&ok);
		if (ok)
			return LGCOutputErrLexer::DECIMAL;
	}
	// special characters
	if (tval.size() == 1)
	{
		switch (tval[0].unicode())
		{
		case ':':
			return LGCOutputErrLexer::COLON;
		case '=':
			return LGCOutputErrLexer::EQUAL;
		case '!':
			return LGCOutputErrLexer::EXCLAMATION;
		case '*':
			return LGCOutputErrLexer::ASTERISK;
		}
	}
	else if (tval.size() > 2 && std::all_of (std::cbegin(tval), std::cend(tval), [](const auto &ch) -> bool { return ch == '*'; }))
		return LGCOutputErrLexer::ASTERISK;
	// keywords - beginning of a line
	if (value.position() == _currentLine.position())
	{
		for (int i = 0; i < LGCOutputErrLexer::TERMINAL_COUNT; i++)
		{
			QString tmptok = LGCOutputErrLexer::spell[i];
			// If equal or has spaces and text starts with it
			if (tmptok == tval || (tmptok.contains(' ') && _currentLine.trimmed().startsWith(tmptok)))
				return i;
		}
	}
	// Ill formatted measurement where there is no space between asterisks and minus signal
	if (tval.startsWith(LGCOutputErrLexer::spell[LGCOutputErrLexer::ILLMEASUREMENT]))
		return LGCOutputErrLexer::ILLMEASUREMENT;
	// Error and Undefined keywords - can be anywhere
	for (int i = LGCOutputErrLexer::INDETERMINE; i <= LGCOutputErrLexer::ERR_ASTERISKS; i++)
	{
		if (tval == LGCOutputErrLexer::spell[i])
			return i;
	}	
	
	return LGCOutputErrLexer::WORD;
}
./
